Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Browser

Namespace InteropDemo2
	Partial Public Class Page
		Inherits UserControl
		Private _other As ScriptObject = Nothing
		Private _dragging As Boolean = False
		Private _pos As Point

		Private ReadOnly Property OtherControl() As ScriptObject
			Get
				If _other Is Nothing Then
					Dim targetControl As HtmlElement = HtmlPage.Document.GetElementById("TargetControl")
					Dim targetContent As ScriptObject = CType(targetControl.GetProperty("content"), ScriptObject)
					_other = CType(targetContent.GetProperty("other"), ScriptObject)
				End If
				Return _other
			End Get
		End Property

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Ball_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
			_dragging = True
			_pos = e.GetPosition(Nothing)
		End Sub

		Private Sub Ball_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
			If _dragging Then
				Dim pos As Point = e.GetPosition(Nothing)
				Dim x As Double = CDbl(Ball.GetValue(Canvas.LeftProperty)) + pos.X - _pos.X
				Dim y As Double = CDbl(Ball.GetValue(Canvas.TopProperty)) + pos.Y - _pos.Y
				Ball.SetValue(Canvas.LeftProperty, x)
				Ball.SetValue(Canvas.TopProperty, y)
				_pos = pos

				OtherControl.Invoke("MoveBall", x, y)
			End If
		End Sub

		Private Sub Ball_MouseLeftButtonUp(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
			_dragging = False
		End Sub

		Private Sub Ball_MouseLeave(ByVal sender As Object, ByVal e As MouseEventArgs)
			_dragging = False
		End Sub
	End Class
End Namespace
